/*----------------------------------------------------------------------------------*/
/*	Copyright (C) Endress+Hauser Metechnik GmbH+Co (2000). All Rights Reserved		*/
/*	Product:		SIMATIC PDM														*/
/*                                                          						*/
/*	Device:			ECHO LEVEL DEVICE for HART										*/
/*	Description:	Device Description												*/
/*	Dictionary:		SIPADC01.dct, EHHA__Micropilot_00.dct							*/
/*                                                          						*/
/*  $Revision:1.4$	 							*/
/*  $Date:05.04.2002$								*/
/*  Obere Revision fr QVCS, untere fr DD, unten die aktuelle angeben 		*/ 
/*  Revision:1.4	 							*/
/*  Date:05.04.2002								*/
/*----------------------------------------------------------------------------------*/
/* Date:                25.06.2001													*/
/* Author:              J. Flegel / ICS GmbH										*/
/* Changed Function(s): Change001 Korrekturen bzgl. Konformittstest vom 18.06.01	*/
/*----------------------------------------------------------------------------------*/
/* Date:                27.06.2001													*/
/* Author:              J. Flegel / ICS GmbH										*/
/* Changed Function(s): Change002 Korrekturen bzgl. Konformittstest vom 18.06.01	*/
/*----------------------------------------------------------------------------------*/
/* Date:                05.04.2002                                              */
/* Version:		1.4							*/
/* Author:              F.Birgel / PCPS     					*/
/* Changed Function(s): HART Standardansicht eingefhrt				*/
/*------------------------------------------------------------------------------*/ 
/* Date:                10.02.2009                                              */
/* Version:		1.5							*/
/* Author:              F.Birgel / PCPS     					*/
/* Changed Function(s): /*Bi change V1.5 fr PDM V6.0SP5*/				
/*------------------------------------------------------------------------------*/
MANUFACTURER	ENDRESS_HAUSER,
DEVICE_TYPE		_FMR23X,
DEVICE_REVISION 2,
DD_REVISION		1

/************************************************************************************/
/*    Macros																		*/
/************************************************************************************/
#define STATUS_SIZE				3
#define STATUS_RESPONSE_CODE	0

/************************************************************************************/
/*    PDM-Menus																		*/
/************************************************************************************/
#include "SIHA.inc"
#include "SI_FileM.inc"
#include "SI_HlpM.inc"
#include "SI_OptM.inc"

#define EXTRA_ITEMS_DEVICE_MENU_SPECIALIST  \
		OnlineDialog_hart_comm,				\
		std_CommWay,					\
		OnlineDialog_burst_mode,			\
		configuration_flag_reset,			\
		SEPARATOR,							\
		OnlineDialog_simulation,			\
		OnlineDialog_reset,					\
		OnlineDialog_service,				\
		SEPARATOR,							\
		OnlineDialog_abgleich,				\
		OnlineDialog_echo,					\
		OnlineDialog_linearization,			\
		SEPARATOR,							\
		OnlineDialog_security_locking		\
		

#include "SI_DevM.inc"

#define EXTRA_ITEMS_VIEW_MENU_SPECIALIST OnlineWindow_diagnosis
#define EXTRA_ITEMS_VIEW_MENU_MAINTENANCE OnlineWindow_diagnosis
#include "SI_ViewM.inc"

/************************************************************************************/
/*    HCF-Import												   					*/
/************************************************************************************/
#include "EHHA__Micropilot_00.inc"

/************************************************************************************/
/*    Trending													   					*/
/************************************************************************************/

#define YT1_LABEL	[V0H0_LABEL_change]
#define YT1_VALUE	measured_parameter
#define	YT1_LRV		display_value_at_04_mA
#define YT1_URV		display_value_at_20_mA

#include "SI_YT.inc"

/************************************************************************************/
/*		Refresh relations															*/
/************************************************************************************/

/*******************************************************************************/
/*****	MENU Bar  **************************************************************/
/*******************************************************************************/
METHOD std_CommWay
{
	LABEL		[menu_Device_CommWay];
	DEFINITION
	{
	}
}

MENU Menu_Main_Specialist
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_S_Device,
		Menu_S_View,
		Menu_Options,
		Menu_Help
	}
}

MENU Menu_Main_Maintenance
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_M_Device,
		Menu_M_View,
		Menu_M_Options,
		Menu_Help
	}
}

/*******************************************************************************/
/*****	Online-Windows  ********************************************************/
/*******************************************************************************/

MENU OnlineWindow_display
{
	LABEL		[menu_dialog_display];
	ITEMS
	{
			Page_display_overview
	}
}

MENU Page_display_overview
{
	LABEL	[menu_dialog_overview];
	ITEMS
	{
		BarVal_process_display
		Val_fill_height,
		Val_fill_distance,
		Val_output_current,
		matrix_par6.simulation_mode	(READ_ONLY),
		device_status				(READ_ONLY)
	 }

}

MENU BarVal_process_display
{
	LABEL		[V0H0_LABEL_change];
	ITEMS
	{
			measured_parameter,		/* VARIABLE */	 	
			display_value_at_04_mA,
			display_value_at_20_mA
	}
}

MENU Val_fill_height
{
	LABEL		[V0H9_LABEL_change];
	ITEMS
	{
			fill_height
	}
}

MENU Val_fill_distance
{
	LABEL		[V0H8_LABEL_change];
	ITEMS
	{
			fill_distance 
	}
}

MENU Val_output_current
{
	LABEL		[V9H8_LABEL_change];
	ITEMS
	{
			output_current 
	}
}

MENU OnlineWindow_diagnosis
{
	LABEL		[menu_dialog_diagnosis];
	ITEMS
	{
		Page_diagnosis_device,
		Page_diagnosis_status_1,
		Page_diagnosis_status_2

	}
}

MENU Page_diagnosis_device
{
	LABEL		[menu_ident_device];
	ITEMS
	{
			matrix_par7.tag,					
			matrix_par6.instr_and_softw_no,
			matrix_par6.instrument_address,		
			manufacturer_id					(READ_ONLY),
			device_type						(READ_ONLY),
			device_id						(READ_ONLY),
			date							(READ_ONLY),							
			universal_revision				(READ_ONLY),
			transmitter_revision			(READ_ONLY),
			hardware_revision				(READ_ONLY),
			software_revision				(READ_ONLY),
			final_assembly_number			(READ_ONLY),
			write_protect					(READ_ONLY)

	}
}

MENU Page_diagnosis_status_1
{
	LABEL	[menu_diagnosis_part_1];
	ITEMS
	{
		device_status					(READ_ONLY),
		matrix_par6.diagnostic_code		(READ_ONLY),
		matrix_par6.last_diagnostic		(READ_ONLY),			
		tank_status,
		xmtr_specific_status_0			(READ_ONLY),
		xmtr_specific_status_1			(READ_ONLY)
	}
}

MENU Page_diagnosis_status_2
{
	LABEL	[menu_diagnosis_part_2];
	ITEMS
	{
		xmtr_specific_status_2			(READ_ONLY),
		xmtr_specific_status_3			(READ_ONLY),
	}
}

/*******************************************************************************/
/*****	Online-Dialogs  ********************************************************/
/*******************************************************************************/

MENU OnlineDialog_hart_comm
{
	LABEL		[menu_HART_Comm];
	ITEMS
	{
			response_preambles 
	}
}

MENU OnlineDialog_burst_mode
{
	LABEL		[menu_burst_mode];
	ITEMS
	{
		burst_mode_select,
		burst_command_number,
	}
}

MENU OnlineDialog_simulation
{
	LABEL  [menu_interface_simulate];
	ITEMS
	{
		matrix_par6.simulation_mode,
		matrix_par6.simulation_value,
	}	
}

MENU OnlineDialog_reset
{
	LABEL		[master_reset];
	HELP		[master_reset_help];
	ITEMS
	{
			matrix_par6.default_values
	}
}

MENU OnlineDialog_security_locking
{
	LABEL		[menu_security_locking];
	ITEMS
	{
			Page_security_locking
	}
}

MENU Page_security_locking
{
	LABEL		[menu_security_locking];
	ITEMS
	{
			write_protect (READ_ONLY),
			matrix_par6.security_locking
	}
}

MENU OnlineDialog_service
{
    LABEL [label_SERVICE];
    ITEMS
    {
		Page_service_access,
		Page_service_data
    }
}

MENU Page_service_access
{
    LABEL [menu_service_locking];
    ITEMS
    {
		matrix_par4.service_index ,			
		matrix_par4.service_locking,
    }
}

MENU Page_service_data
{
    LABEL [menu_service_data];
    ITEMS
    {
		matrix_par4.z_distance ,			
		matrix_par4.type_of_antenna ,		
		matrix_par4.module_type ,			
		matrix_par4.record_tvg ,			
		matrix_par4.tank_status ,			
		matrix_par4.minimum_sn ,			
		matrix_par4.mam_configuration ,		
		matrix_par4.uncorrected_distance,
		meth_transfer //Change002
    }
}

//Change002 start
METHOD meth_transfer
{
	LABEL	[transfer];
	DEFINITION
	{
	}
	VALIDITY IF (service_locking == 1163) {TRUE;} ELSE {FALSE;}
}
//Change002 end
MENU OnlineDialog_abgleich
{
	LABEL		[OnlineDialog_txt_abgleich];
	HELP		[OnlineDialog_txt_abgleich_help];
	ITEMS
	{   
		matrix_par1.empty_value,                                   
		matrix_par1.full_value,                                    
		matrix_par1.application                                  
	}
}

MENU OnlineDialog_echo
{
    LABEL [label_echo_suppress];
	ITEMS
	{
		matrix_par3.echo_suppress,
		matrix_par3.distance_suppress	(READ_ONLY),
		matrix_par1.fill_distance,
		matrix_par6.diagnostic_code,
		//Change002 entfernt: matrix_par6.last_diagnostic

		meth_v3_transmit
	}
}


MENU OnlineDialog_linearization
{
	LABEL		[menu_dialog_linearization];
    ITEMS
    {   
		Page_linearization_view,
		Page_linearization_input
    }
}

MENU Page_linearization_view
{
	LABEL		[menu_dialog_linearization_read];
	ITEMS
	{
		Group_linearization_status,
		matrix_par2.linearization_mode(READ_ONLY),	
		matrix_par2.xy_table_index_1,			
		matrix_par2.xy_table_X	(READ_ONLY),
		matrix_par2.xy_table_Y	(READ_ONLY),	
		matrix_par2.vmax		(READ_ONLY),
		method_set
	}
}

MENU Page_linearization_input
{
	LABEL		[menu_dialog_linearization_input];
	ITEMS
	{
		Group_linearization_status,
		matrix_par2.linearization_mode,	
		matrix_par2.xy_table_index_1,				
		matrix_par2.xy_table_X ,
		matrix_par2.xy_table_Y,	
		matrix_par2.vmax,				
		method_set
	}
}

MENU Group_linearization_status
{
	LABEL		[menu_dialog_linearization_status];
	ITEMS
	{
		matrix_par6.diagnostic_code					
	}
}


METHOD meth_read
{
	LABEL	[meth_read];
	DEFINITION
	{}
}

METHOD meth_linearization_mode
{
	LABEL		[meth_change];
	DEFINITION
	{
		char status[STATUS_SIZE], text[];

		text = linearization_mode.LABEL + ":";

		GET_DEV_VAR_VALUE(text, linearization_mode);
		iassign(variable_array_index,0x20);           /* VH20:  meth_linearization_mode */
        send(145,status);                             /* write  linearization_mode */
		if ( status[STATUS_RESPONSE_CODE] )
		{
		display_response_status(145,status[STATUS_RESPONSE_CODE]);
		}
	}
}

// --- Parameter table --------------------------------------------------------
//start Bi Menu changes
MENU Table_Main_Specialist
{
	LABEL	[phys_device_id];
	ITEMS
	{
		Tab_s_EH_Std_Matrix
		Tab_s_HART_Menu
	}
}

MENU Table_Main_Maintenance
{
	LABEL	[phys_device_id];
	ITEMS
	{
		Tab_m_EH_Std_Matrix,
		Tab_m_HART_Menu
	}
}

MENU Tab_s_HART_Menu
{
	LABEL	[label_HART_Menu];
	ITEMS
	{
		Tab_s_ident
	}
}

MENU Tab_m_HART_Menu
{
	LABEL	[label_HART_Menu];
	ITEMS
	{
		Tab_m_ident
	}
}

MENU Tab_s_ident
{
	LABEL		[menu_ident];
	ITEMS
	{	
		Tab_s_ident_opunit1,	
		Tab_s_ident_device
	}
}

MENU Tab_m_ident
{
	LABEL		[menu_ident];
	ITEMS
	{	
		Tab_m_ident_opunit1,	
		Tab_m_ident_device
	}
}

MENU Tab_s_ident_opunit1
{
	LABEL		[menu_ident_opunit];
	ITEMS
	{
		tag,
		message,
		descriptor
	}
}

MENU Tab_m_ident_opunit1
{
	LABEL		[menu_ident_opunit];
	ITEMS
	{
		tag(READ_ONLY),
		message(READ_ONLY),
		descriptor(READ_ONLY)
	}
}

MENU Tab_s_ident_device
{
	LABEL	[menu_ident_device];
	ITEMS
	{
		manufacturer_id (READ_ONLY),
		device_type (READ_ONLY),
		device_id (READ_ONLY),
		universal_revision (READ_ONLY),
		transmitter_revision (READ_ONLY),
		software_revision (READ_ONLY),
		hardware_revision (READ_ONLY),
		device_flags (READ_ONLY),
		physical_signaling_code (READ_ONLY),
		final_assembly_number,
		write_protect (READ_ONLY),
		date
	}
}

MENU Tab_m_ident_device
{
	LABEL	[menu_ident_device];
	ITEMS
	{
		manufacturer_id (READ_ONLY),
		device_type (READ_ONLY),
		device_id (READ_ONLY),
		universal_revision (READ_ONLY),
		transmitter_revision (READ_ONLY),
		software_revision (READ_ONLY),
		hardware_revision (READ_ONLY),
		device_flags (READ_ONLY),
		physical_signaling_code (READ_ONLY),
		final_assembly_number (READ_ONLY),
		write_protect (READ_ONLY),
		date (READ_ONLY)
	}
}
//end Bi Menu changes


// --- End Parameter Table
UNIT displayed_unit_relation
{
		displayed_unit:	
		sensor_lower_limit,
		sensor_upper_limit,
}



MENU Tab_s_EH_Std_Matrix
{
	LABEL	[menu_table_EH_Std_Matrix];
	ITEMS
	{
		CALIBRATION,
		LINEARIZATION,
		EXTENDED_CALIBRATION,
		SERVICES,
		OPERATOR,
		SIMULATION,
		COMMUNICATION
	}
}

MENU Tab_m_EH_Std_Matrix
{
	LABEL	[menu_table_EH_Std_Matrix];
	ITEMS
	{
		CALIBRATION_m,
		LINEARIZATION_m,
		EXTENDED_CALIBRATION_m,
		SERVICES_m,
		OPERATOR_m,
		SIMULATION_m,
		COMMUNICATION_m
	}
}

CALIBRATION_m LIKE MENU CALIBRATION
{
	REDEFINE ITEMS
	{
		matrix_par1.measured_parameter		(READ_ONLY),
		matrix_par1.empty_value				(READ_ONLY),
		matrix_par1.full_value				(READ_ONLY),
		help_application,
		matrix_par1.level_damping			(READ_ONLY),
		matrix_par1.display_value_at_04_mA	(READ_ONLY),
		matrix_par1.display_value_at_20_mA	(READ_ONLY),
		matrix_par1.alarm_selection_code_1	(READ_ONLY),
		matrix_par1.fill_distance			(READ_ONLY),
		matrix_par1.fill_height				(READ_ONLY)
	}
}

LINEARIZATION_m LIKE MENU LINEARIZATION
{
	REDEFINE ITEMS
	{
		help_linearization_mode,	//Change002	
		help_xy_table_index_1 ,          
		help_xy_table_X ,                
		help_xy_table_Y ,                
		help_vmax                        
	}
}

EXTENDED_CALIBRATION_m LIKE MENU EXTENDED_CALIBRATION
{
	REDEFINE ITEMS
	{
		help_echo_suppress,					
		matrix_par3.distance_suppress	(READ_ONLY)
		matrix_par3.echo_quality		(READ_ONLY),			        
		matrix_par3.micro_factor		(READ_ONLY),					
		matrix_par3.first_echo			(READ_ONLY),
		matrix_par3.window_suppress		(READ_ONLY),				
		matrix_par3.offset				(READ_ONLY)
	}
}

SERVICES_m LIKE MENU SERVICES
{
	REDEFINE ITEMS	
	{
		help_V7,
		matrix_par4.service_index		(READ_ONLY),			
		matrix_par4.z_distance			(READ_ONLY),			
		matrix_par4.type_of_antenna 	(READ_ONLY),		
		matrix_par4.module_type 		(READ_ONLY),			
		matrix_par4.record_tvg 			(READ_ONLY),			
		matrix_par4.tank_status 		(READ_ONLY),			
		matrix_par4.minimum_sn 			(READ_ONLY),			
		matrix_par4.mam_configuration 	(READ_ONLY),		
		matrix_par4.uncorrected_distance(READ_ONLY),	
		matrix_par4.service_locking 	(READ_ONLY)	
	}
}

OPERATOR_m LIKE MENU OPERATOR
{
	REDEFINE ITEMS
	{
		matrix_par5.current_output_mode			(READ_ONLY),
		matrix_par5.select_distance_unit		(READ_ONLY),
		matrix_par5.delay_time					(READ_ONLY),				
		matrix_par5.quit_mode					(READ_ONLY),
		matrix_par5.plausibility_mode			(READ_ONLY)
	}
}

SIMULATION_m LIKE MENU SIMULATION
{
	REDEFINE ITEMS
	{
		matrix_par6.diagnostic_code			(READ_ONLY),
		matrix_par6.last_diagnostic			(READ_ONLY),
		matrix_par6.instr_and_softw_no		(READ_ONLY),
		help_instrument_address ,		
		help_default_values,      		
		help_simulation_mode ,			
		matrix_par6.simulation_value		(READ_ONLY),
		matrix_par6.output_current			(READ_ONLY),
		help_security_locking 			
	}
}

COMMUNICATION_m LIKE MENU COMMUNICATION
{
	REDEFINE ITEMS
	{
		matrix_par7.tag,
		matrix_par7.unit_after_lin			(READ_ONLY)
	}
}


/*******************************************************************************/
/*****	Commands  **************************************************************/
/*******************************************************************************/
VARIABLE local_abort
{
	LABEL	"ABORT";
	TYPE INTEGER
	{
		DEFAULT_VALUE	0;
	}
}

METHOD pre_read_download_variables
{
	CLASS		INPUT;
	DEFINITION
	{
		int ret;
		char status [STATUS_SIZE];

		local_abort = 0; //kein Abbruch

		IGNORE_ALL_RESPONSE_CODES();
		IGNORE_ALL_DEVICE_STATUS();
		XMTR_IGNORE_ALL_DEVICE_STATUS();

		iassign (variable_array_index, 0x96) ;	//simulation_mode
		send(144, status);

		if ( status[STATUS_RESPONSE_CODE] )
		{
		display_response_status(145, status[STATUS_RESPONSE_CODE]) ;
		}


	}
}

// kein download_variables => alle Parameter lesen

MENU download_variables
{
	LABEL		[menu_load_to_PC];
	PRE_READ_ACTIONS
	{
		pre_read_download_variables
	}
	ITEMS
	{
	
		IF (local_abort == 0)
		{
			tag,
			descriptor,
			message,
			manufacturer_id,
			device_type,
			device_id,
			private_label_distributor,
			universal_revision,
			transmitter_revision,
			hardware_revision,
			software_revision,
			date,
			instr_and_softw_no,
			instrument_address,
			//application, //Dialog
			current_output_mode,
			delay_time,
			quit_mode,
			plausibility_mode,
			select_distance_unit,
			calibration_unit,

//			echo_suppress,
			distance_suppress,
			echo_quality,
			micro_factor,
			first_echo,
			window_suppress,
			offset,

			service_index,
			z_distance,
			type_of_antenna,
			module_type,
			record_tvg,
			tank_status,
			minimum_sn,
			mam_configuration,
			uncorrected_distance,
			service_locking,

			sensor_lower_limit,
			sensor_upper_limit,
			display_value_at_04_mA,
			display_value_at_20_mA,
			alarm_selection_code_1,
			linearization_mode,
			xy_table_index_1,
			xy_table_X,
			xy_table_Y,
			vmax,
			level_damping,

			// Parameter die nur im hersteller spez. Bereich vorkommen
//			diagnostic_code,
			last_diagnostic,
//			default_values,
			output_current,
//			security_locking,
			unit_after_lin,
			write_protect,
			measured_parameter,
			empty_value,
			full_value,
			fill_distance,
			fill_height,

			//simulation_mode,			//pre_read_download_variables
			IF (simulation_mode != 0)
			{
				simulation_value
			}

		}	// IF (local_abort == 0)
	}
}

/*upload_variables siehe REDEFINE in EHHA__Micropilot_00.inc */

METHOD meth_v3_transmit
{
	LABEL	[transfer];
	HELP	[transfer_help];
	DEFINITION
	{
		char status[STATUS_SIZE];
		int v30;
		long i;
		int ret;
		int abb;
		float f1, f2;
		long v3h1unit[1];
		
		v30=ivar_value(echo_suppress);
		// in jedem Fall v30 = 0 runterschreiben
		iassign(echo_suppress, 0);
//		WriteCommand(echo_suppress);
		variable_array_index = 0x30;
		send(145,status);                        
			
		if (0!=v30)
		{
//			ReadCommand(distance_suppress);
			variable_array_index = 0x31;//distance_supress
			send(144,status);                        
			f1=fvar_value(distance_suppress);
			_TRACE(f1);

//			WriteCommand(echo_suppress);
			iassign(echo_suppress, v30);
			variable_array_index = 0x30;
			send(145,status);                        

			if (1!=v30)
			{

				i=0;
				abb=0;

				while (abb==0)
				{
					i++;
//					ReadCommand(distance_suppress);
					variable_array_index = 0x31;
					send(144,status);                        
					f2=fvar_value(distance_suppress);
					_TRACE(f2);

					if ((i>100)||(f1!=f2))
					{
						abb=1;
//			acknowledge("while: Abbruch f1 = %{f1}, f2 = %{f2}",v3h1unit);
					}
				}
			}
		}

		if ((2==v30)||(3==v30)||(4==v30))
		{
			v3h1unit[0] = VARID(select_distance_unit);
//			ReadCommand(distance_suppress);
			variable_array_index = 0x31;
			send(144,status);  
			ret = get_dev_var_value([ack_choice_suppression_distance], v3h1unit, distance_suppress);
//			WriteCommand(distance_suppress);
			variable_array_index = 0x31;
			send(145,status);  
		}
	}
}

